diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicThermalVent.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicThermalVent.java
index 8ba5af230..c04ab6df9 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicThermalVent.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicThermalVent.java
@@ -38,7 +38,7 @@ public class BlockLogicThermalVent extends BlockLogic {
 
         world.spawnParticle("ventsmoke", xPos, yPos, zPos, 0.0D, 0.005D, 0.0D, 1, 1000, true);
 
-        if (state >= VENTING_STATE - 1) {
+        if (hasVentBelow(world, tilePos) && state >= VENTING_STATE - 1) {
             for (int i = 0; i < 4; i++) {
                 world.spawnParticle("ventsmoke", xPos, yPos, zPos, 0.0D, 0.005D, 0.0D, 0, 1000.0, true);
                 world.spawnParticle("smoke", xPos + rand.nextFloat() - 0.5D, yPos, zPos + rand.nextFloat() - 0.5D, 0.0D, 0.005D, 0.0D, 1, 1000.0, true);
@@ -53,12 +53,30 @@ public class BlockLogicThermalVent extends BlockLogic {
         return 1;
     }
 
+    private static boolean hasVentBelow(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        return Block.hasLogicClass(world.getBlockType(tilePos.down(new TilePos())), BlockLogicThermalVent.class);
+    }
+
+    @Override
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
+        if (!hasVentBelow(world, tilePos) && getVentState(world.getBlockData(tilePos)) != DORMANT_STATE) {
+            world.setBlockDataNotify(tilePos, DORMANT_STATE);
+        }
+    }
+
     @Override
     public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) {
         if (world.getBlockType(tilePos.up(new TilePos())).solid()) {
             return;
         }
 
+        if (!hasVentBelow(world, tilePos)) {
+            if (getVentState(world.getBlockData(tilePos)) != DORMANT_STATE) {
+                world.setBlockDataNotify(tilePos, DORMANT_STATE);
+            }
+            return;
+        }
+
         if (rand.nextInt(4) != 0) {
             int state = getVentState(world.getBlockData(tilePos));
             if (state < VENTING_STATE) {
@@ -120,7 +138,7 @@ public class BlockLogicThermalVent extends BlockLogic {
         super.onPlacedByWorld(world, tilePos);
 
         if (!world.isClientSide) {
-            world.setBlockDataNotify(tilePos, world.rand.nextInt(VENTING_STATE));
+            world.setBlockDataNotify(tilePos, hasVentBelow(world, tilePos) ? world.rand.nextInt(VENTING_STATE) : DORMANT_STATE);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJarButterfly.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJarButterfly.java
index 77121d8e1..968a58315 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJarButterfly.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJarButterfly.java
@@ -32,6 +32,6 @@ public class TileEntityJarButterfly extends TileEntity{
 
     @Override
     public void writeAdditionalData(@NotNull CompoundTag compoundTag) {
-        compoundTag.putByte("color", (byte) color.id);
+        compoundTag.putByte("color", (byte) color.id());
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/ICapturable.java b/game/core/src/main/java/net/minecraft/core/entity/ICapturable.java
new file mode 100644
index 000000000..92a6c4770
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/entity/ICapturable.java
@@ -0,0 +1,25 @@
+package net.minecraft.core.entity;
+
+import org.jetbrains.annotations.NotNull;
+
+import net.minecraft.core.item.Item;
+
+public interface ICapturable {
+    boolean canBeCapturedBy(@NotNull Item item);
+    int onCaptured(int amount, boolean acceptPartial);
+    
+    default int onCaptured() { return this.onCaptured(1, true); }
+    default int onCaptured(int amount) { return this.onCaptured(amount, true); }
+
+    static interface Singular extends ICapturable {
+        void onSingularCaptured();
+
+        @Override
+        default int onCaptured(int amount, boolean acceptPartial) {
+            if (amount < 1) return 0;
+            if (!acceptPartial && amount > 1) return 0;
+            this.onSingularCaptured();
+            return 1;
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index af4f33c56..363436919 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -4,6 +4,7 @@ import com.b100.utils.StringUtils;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemFood;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.WeightedRandomLootObject;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java
index 98a7d3ff3..1f983e42d 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java
@@ -9,10 +9,12 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.ICapturable;
 import net.minecraft.core.entity.MobFlying;
 import net.minecraft.core.entity.SkinVariantList;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemJar;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
@@ -22,12 +24,10 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
 
-import java.util.Arrays;
-import java.util.HashSet;
 import java.util.Set;
 import java.util.function.Supplier;
 
-public class MobButterfly extends MobFlying implements AmbientCreature {
+public class MobButterfly extends MobFlying implements AmbientCreature, ICapturable.Singular {
     public static final Int2ObjectMap<ButterflyEntry> colorEntries = new Int2ObjectArrayMap<>();
 
     public static final int DATA_COLOR_ID = 16;
@@ -38,8 +38,8 @@ public class MobButterfly extends MobFlying implements AmbientCreature {
     public static final ButterflyEntry COLOR_SILVER;
 
     public static ButterflyEntry addEntry(int id, String name, double weight, Supplier<Item> jarItem, Biome... allowedBiomes) {
-        assert id >= 0 && id <= 0xFF : "ID is outside valid range!";
-        ButterflyEntry entry = new ButterflyEntry(id, name, weight, jarItem, allowedBiomes);
+        assert (id & ~0xFF) == 0 : "ID is outside valid range!";
+        final var entry = new ButterflyEntry(id, name, weight, jarItem, allowedBiomes);
         colorEntries.put(id, entry);
         return entry;
     }
@@ -284,45 +284,37 @@ public class MobButterfly extends MobFlying implements AmbientCreature {
         return colorEntries.get(getColor()).name + "/" + variantList.getSkinReference(this.variantJsonPath, "0", getSkinVariant());
     }
 
-    public static class ButterflyEntry {
-        public final int id;
-        public final String name;
-        /** Biomes which the color can appear, null indicates any biome*/
-        private @Nullable Set<Biome> allowedBiomes;
-        public final Supplier<Item> jarItem;
-        public final double weight;
-
-        public ButterflyEntry(int id, String name, double weight, Supplier<Item> jarItem, Biome... allowedBiomes) {
-            this.id = id;
-            this.name = name;
-            this.weight = weight;
-            this.jarItem = jarItem;
-
-            if (allowedBiomes.length > 0) {
-                this.allowedBiomes = new HashSet<>();
-                this.allowedBiomes.addAll(Arrays.asList(allowedBiomes));
-            }
+    public static record ButterflyEntry(
+        int id,
+        @NotNull String name,
+        double weight,
+        @NotNull Supplier<@NotNull Item> jarItemLazy,
+        @Nullable Set<Biome> allowedBiomes
+    ) {
+        public ButterflyEntry(
+            int id,
+            @NotNull String name,
+            double weight,
+            @NotNull Supplier<@NotNull Item> jarItemLazy,
+            Biome... allowedBiomes
+        ) {
+            this(id, name, weight, jarItemLazy, allowedBiomes.length == 0 ? null : Set.of(allowedBiomes));
         }
 
-        public ButterflyEntry addAllowedBiome(Biome biome) {
-            if (this.allowedBiomes == null) this.allowedBiomes = new HashSet<>();
-            this.allowedBiomes.add(biome);
-            return this;
+        public @NotNull Item jarItem() { return this.jarItemLazy.get(); }
+        public boolean isBiomeAllowed(Biome biome) {
+            return this.allowedBiomes == null || this.allowedBiomes.contains(biome);
         }
+    }
 
-        public ButterflyEntry removeAllowedBiome(Biome biome) {
-            if (this.allowedBiomes == null) this.allowedBiomes = new HashSet<>();
-            this.allowedBiomes.remove(biome);
-            return this;
-        }
 
-        public ButterflyEntry allowAllBiomes() {
-            this.allowedBiomes = null;
-            return this;
-        }
+    @Override
+    public boolean canBeCapturedBy(@NotNull Item item) {
+        return item instanceof ItemJar;
+    }
 
-        public boolean isBiomeAllowed(Biome biome) {
-            return this.allowedBiomes == null || this.allowedBiomes.contains(biome);
-        }
+    @Override
+    public void onSingularCaptured() {
+        this.remove();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
index 6b05f57ac..325eec7b6 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
@@ -6,8 +6,11 @@ import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.ICapturable;
 import net.minecraft.core.entity.MobFlying;
 import net.minecraft.core.enums.LightLayer;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemJar;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
@@ -20,7 +23,7 @@ import java.util.Collection;
 import java.util.List;
 
 public class MobFireflyCluster extends MobFlying
-    implements AmbientCreature {
+    implements AmbientCreature, ICapturable {
     public static final int DATA_COLOR_ID = 16;
     public static final int DATA_CLUSTER_SIZE_ID = 17;
     public static final int DATA_COUNT_ID = 18;
@@ -412,6 +415,26 @@ public class MobFireflyCluster extends MobFlying
         return true;
     }
 
+
+    @Override
+    public boolean canBeCapturedBy(@NotNull Item item) {
+        return item instanceof ItemJar;
+    }
+
+    @Override
+    public int onCaptured(int amount, boolean acceptPartial) {
+        if (amount < 1) return 0;
+
+        int count = this.getFireflyCount();
+        if (!acceptPartial && amount > count) return 0;
+        
+        count -= amount;
+        this.setFireflyCount(count);
+        if (count == 0) this.remove();
+
+        return count;
+    }
+
     public static class FireflyColor {
         public static Int2ObjectMap<FireflyColor> fireFlyColors = new Int2ObjectArrayMap<>();
         public static FireflyColor GREEN = register(new FireflyColor(0, "fireflyGreen", new Biome[]{
diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index bbc257449..b28e6ac3a 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -59,6 +59,9 @@ import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
+import net.minecraft.core.world.type.WorldType;
+import net.minecraft.core.world.type.WorldTypes;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 import net.minecraft.core.world.weather.Weathers;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -1635,28 +1638,36 @@ public abstract class Player
         double oneFifthOfRadius = maxRadius * 0.2;
         double threeFifthsOfRadius = maxRadius * 0.6;
 
+        boolean isNether = player.world.getWorldType().hasTag(WorldTypeTags.NETHER);
+
         float randomizedPitch = 0.8F + (this.world.rand.nextFloat() - this.world.rand.nextFloat()) * 0.45F;
 
         if (distance <= oneFifthOfRadius) {
             this.world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS,
                 ventCoordinateX, ventCoordinateY, ventCoordinateZ,
             "tile.crumble", 20.0F, randomizedPitch);
-            this.world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS,
-                ventCoordinateX, ventCoordinateY, ventCoordinateZ,
-            "tile.deepboom", 20.0F, randomizedPitch);
+            if(isNether) {
+                this.world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS,
+                    ventCoordinateX, ventCoordinateY, ventCoordinateZ,
+                "tile.deepboom", 20.0F, randomizedPitch);
+            }
         }
         else if (distance <= threeFifthsOfRadius) {
             this.world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS,
                 ventCoordinateX, ventCoordinateY, ventCoordinateZ,
             "tile.deepcrumble", 20.0F, randomizedPitch);
-            this.world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS,
-                ventCoordinateX, ventCoordinateY, ventCoordinateZ,
-            "tile.deepquietboom", 20.0F, randomizedPitch);
+            if(isNether) {
+                this.world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS,
+                    ventCoordinateX, ventCoordinateY, ventCoordinateZ,
+                "tile.deepquietboom", 20.0F, randomizedPitch);
+            }
         }
         else {
-            this.world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS,
-                ventCoordinateX, ventCoordinateY, ventCoordinateZ,
-            "tile.deepquietboom", 20.0F, randomizedPitch);
+            if(isNether) {
+                this.world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS,
+                    ventCoordinateX, ventCoordinateY, ventCoordinateZ,
+                "tile.deepquietboom", 20.0F, randomizedPitch);
+            }
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/item/IAccumulatable.java b/game/core/src/main/java/net/minecraft/core/item/IAccumulatable.java
new file mode 100644
index 000000000..37a4d2409
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/item/IAccumulatable.java
@@ -0,0 +1,181 @@
+package net.minecraft.core.item;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.TileEntityActivator;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumBlockSoundEffectType;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+
+import java.util.Random;
+
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
+
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+
+public interface IAccumulatable<T extends BlockLogic> extends IPlaceable.PlaceableBlock<T> {
+    
+    boolean canAccumulateInto(
+        @NotNull ItemStack selfStack,
+        @NotNull Block<?> block, int data, @NotNull Side side, double xHit, double yHit);
+
+    /**
+     * @param result out parameter, .block and .data are by default the current block and data at position
+     */
+    @NotNull BlockDataResult getAccumulationResult(
+        @NotNull ItemStack selfStack,
+        @NotNull World world, @Nullable Player player, @NotNull TilePosc tilePos,
+        @NotNull Side side, double xHit, double yHit,
+        @NotNull BlockDataResult result);
+        
+    default void postAccumulate(
+        @NotNull ItemStack selfStack,
+        @NotNull World world, @Nullable Player player, @NotNull TilePosc tilePos,
+        @NotNull Side side, double xHit, double yHit,
+        @NotNull BlockDataResult result
+    ) {}
+
+    public static class BlockDataResult {
+        public @NotNull Block<?> block;
+        public int data;
+        public boolean doRawPlacing;
+        public boolean shouldUpdateNeighbors;
+        public boolean shouldConsumeItem;
+        public boolean shouldPlaySound;
+        public final @NotNull AABBd bounds;
+
+        public BlockDataResult() {
+            this(new AABBd().set(INVALID_BB));
+        }
+        public BlockDataResult(@NotNull AABBd bounds) {
+            this.bounds = bounds;
+            this.reset();
+        }
+    
+        public void reset() {
+            this.block = Blocks.AIR;
+            this.data = 0;
+            this.doRawPlacing = false;
+            this.shouldUpdateNeighbors = true;
+            this.shouldConsumeItem = true;
+            this.shouldPlaySound = true;
+            this.removeBounds();
+        }
+
+        public void removeBounds() {
+            this.bounds.set(INVALID_BB);
+        }
+
+        private static final @NotNull AABBdc INVALID_BB = new AABBd(
+            Double.POSITIVE_INFINITY,Double.POSITIVE_INFINITY,Double.POSITIVE_INFINITY,
+            Double.NEGATIVE_INFINITY,Double.NEGATIVE_INFINITY,Double.NEGATIVE_INFINITY);
+    }
+
+    @Override
+    default boolean placeOnBlock(
+        @NotNull ItemStack selfStack,
+        @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos,
+        @NotNull Side side, double xHit, double yHit
+    ) {
+        return this.placeOnBlockAccumulatable(true, selfStack, world, player, blockPos, side, xHit, yHit);
+    }
+
+    @Override
+    default void placeByActivator(
+        @NotNull ItemStack selfStack,
+        @NotNull World world, @NotNull TileEntityActivator activator,
+        @NotNull Random random, @NotNull TilePosc blockPos,
+        @NotNull Direction direction, double offX, double offY, double offZ
+    ) {
+        blockPos = blockPos.add(direction, new TilePos());
+        this.placeOnBlockAccumulatable(false, selfStack, world, null, blockPos, direction.opposite().side(), Double.NaN, Double.NaN);
+    }
+
+    @Override
+    default boolean placeWithoutShift(
+        @NotNull ItemStack selfStack,
+        @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos,
+        @NotNull Side side, double xHit, double yHit
+    ) {
+        return this.placeOnBlockAccumulatable(false, selfStack, world, player, blockPos, side, xHit, yHit);
+    }
+    
+    static boolean defaultPlaceWithoutShift(
+        @NotNull IAccumulatable<?> self,
+        @NotNull ItemStack selfStack,
+        @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos,
+        @NotNull Side side, double xHit, double yHit
+    ) {
+        if (!self.canPlaceDirectlyAtPosition(selfStack, world, player, blockPos, side, xHit, yHit)) return false;
+
+        final int meta = self.getPlacedData(selfStack, world, player, blockPos, side, xHit, yHit);
+        return self.placeDirectly(selfStack, world, player, blockPos, meta, side, xHit, yHit);
+    }
+
+    default boolean placeOnBlockAccumulatable(
+        boolean shift,
+        @NotNull ItemStack selfStack,
+        @NotNull World world, @Nullable Player player, @NotNull TilePosc tilePos,
+        @NotNull Side side, double xHit, double yHit
+    ) {
+        if (selfStack.stackSize <= 0) return false;
+
+        var block = world.getBlockType(tilePos);
+        var data = world.getBlockData(tilePos);
+
+        if (!this.canAccumulateInto(selfStack, block, data, side, xHit, yHit)) {
+            if (!this.shouldShiftOutOf(selfStack, world, player, tilePos, side, xHit, yHit))
+                return defaultPlaceWithoutShift(this, selfStack, world, player, tilePos, side, xHit, yHit);
+            if (!shift) return false;
+
+            tilePos = tilePos.add(side, new TilePos());
+            yHit -= side.offsetY();
+            xHit -= side.offsetX() + side.offsetZ();
+            block = world.getBlockType(tilePos);
+            data = world.getBlockData(tilePos);
+
+            if (!this.canAccumulateInto(selfStack, block, data, side, xHit, yHit))
+                return defaultPlaceWithoutShift(this, selfStack, world, player, tilePos, side, xHit, yHit);
+        }
+
+        interface ctx {
+            BlockDataResult result = new BlockDataResult();
+            AABBd queryBB = new AABBd();
+        }
+        synchronized(ctx.result) {
+            ctx.result.reset();
+            ctx.result.block = block;
+            ctx.result.data = data;
+
+            final var result = this.getAccumulationResult(selfStack, world, player, tilePos, side, xHit, yHit, ctx.result);
+
+            if (result.bounds.isValid()) {
+                ctx.queryBB.set(result.bounds).translate(tilePos.x(), tilePos.y(), tilePos.z());
+                if (!world.checkIfAABBIsClear(ctx.queryBB)) return false;
+            }
+            
+            final boolean placed = (result.doRawPlacing)
+                ? world.setBlockTypeDataRaw(tilePos, result.block, result.data)
+                : world.setBlockTypeData(tilePos, result.block, result.data);
+            if (!placed) return false;
+            
+            if (result.shouldConsumeItem) selfStack.consumeItem(player);
+
+            this.postAccumulate(selfStack, world, player, tilePos, side, xHit, yHit, result);
+            if (result.shouldUpdateNeighbors) world.notifyBlockChange(tilePos, block);
+
+            if (result.shouldPlaySound) world.playBlockSoundEffect(player,
+                tilePos.x() + 0.5F, tilePos.y() + 0.5F, tilePos.z() + 0.5F,
+                block, EnumBlockSoundEffectType.PLACE);
+
+            return true;
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/item/IPlaceable.java b/game/core/src/main/java/net/minecraft/core/item/IPlaceable.java
new file mode 100644
index 000000000..77015e3a6
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/item/IPlaceable.java
@@ -0,0 +1,162 @@
+package net.minecraft.core.item;
+
+import java.util.Random;
+
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.entity.TileEntityActivator;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumBlockSoundEffectType;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+
+public interface IPlaceable {
+    boolean shouldShiftOutOf(
+        @NotNull ItemStack selfStack, 
+        @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos,
+        @NotNull Side side, double xHit, double yHit
+    );
+
+    boolean canPlaceDirectlyAtPosition(
+        @NotNull ItemStack selfStack, 
+        @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos,
+        @NotNull Side side, double xHit, double yHit
+    );
+
+    public static boolean shouldShiftBlockOutOf(
+        @NotNull Block<?> block, @NotNull World world, @NotNull TilePosc blockPos
+    ) {
+        if (!world.canPlaceInsideBlock(blockPos)) return true;
+        return block.hasTag(BlockTags.PLACE_OVERWRITES) && 
+            block == world.getBlockType(blockPos);
+    }
+
+    public static boolean canPlaceBlockDirectlyAtPosition(
+        @NotNull Block<?> block, @NotNull World world,
+        @NotNull TilePosc blockPos, @NotNull Side side
+    ) {
+        return world.canBlockIdBePlacedAt(block.id(), blockPos, false, side);
+    }
+
+    boolean placeWithoutShift(
+        @NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player,
+        @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit
+    );
+
+    default boolean placeOnBlock(
+        @NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player,
+        @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit
+    ) {
+        if (this.shouldShiftOutOf(selfStack, world, player, blockPos, side, xHit, yHit)) blockPos = blockPos.add(side.direction(), new TilePos());
+        return this.placeWithoutShift(selfStack, world, player, blockPos, side, xHit, yHit);
+    }
+
+    default void placeByActivator(
+        @NotNull ItemStack selfStack, @NotNull World world,
+        @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos,
+        @NotNull Direction direction, double offX, double offY, double offZ
+    ) {
+        blockPos = new TilePos(blockPos).add(direction);
+        this.placeWithoutShift(selfStack, world, null, blockPos, direction.side().opposite(), 0.5f, 0.5f);
+    }
+
+    public static interface PlaceableBlock<T extends BlockLogic> extends IPlaceable {
+        @NotNull Block<T> getBlock();
+
+        @Override
+        default boolean shouldShiftOutOf(
+            @NotNull ItemStack selfStack, 
+            @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos,
+            @NotNull Side side, double xHit, double yHit
+        ) {
+            return shouldShiftBlockOutOf(this.getBlock(), world, blockPos);
+        }
+
+        @Override
+        default boolean canPlaceDirectlyAtPosition(
+            @NotNull ItemStack selfStack, 
+            @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos,
+            @NotNull Side side, double xHit, double yHit
+        ) {
+            return canPlaceBlockDirectlyAtPosition(this.getBlock(), world, blockPos, side);
+        }
+
+        default boolean placeWithMeta(
+            @NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player,
+            @NotNull TilePosc blockPos, int meta, @NotNull Side side, double xHit, double yHit
+        ) {
+            if (this.shouldShiftOutOf(selfStack, world, player, blockPos, side, xHit, yHit)) blockPos = blockPos.add(side.direction(), new TilePos());
+            if (!this.canPlaceDirectlyAtPosition(selfStack, world, player, blockPos, side, xHit, yHit)) return false;
+
+            return this.placeDirectly(selfStack, world, player, blockPos, meta, side, xHit, yHit);
+        }
+
+        default int getPlacedData(
+            @NotNull ItemStack selfStack,
+            @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos,
+            @NotNull Side side, double xHit, double yHit
+        ) {
+            return this.getBlock().getPlacedData(player, selfStack, world, blockPos, side, xHit, yHit);
+        }
+
+        @Override
+        default boolean placeWithoutShift(
+            @NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player,
+            @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit
+        ) {
+            if (!this.canPlaceDirectlyAtPosition(selfStack, world, player, blockPos, side, xHit, yHit)) return false;
+
+            final int meta = this.getPlacedData(selfStack, world, player, blockPos, side, xHit, yHit);
+            return this.placeDirectly(selfStack, world, player, blockPos, meta, side, xHit, yHit);
+        }
+
+        default boolean placeDirectly(
+            @NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player,
+            @NotNull TilePosc blockPos, int meta, @NotNull Side side, double xHit, double yHit
+        ) {
+            if (selfStack.stackSize <= 0) return false;
+            final var pbloc = world.getBlockType(blockPos);
+            final int pdata = world.getBlockData(blockPos);
+
+            final var selfBlock = this.getBlock();
+
+            if (!world.setBlockTypeDataRaw(blockPos, selfBlock, meta)) return false;
+
+            if (pbloc != selfBlock || pdata != meta) {
+                pbloc.onRemoved(world, blockPos, pdata);
+            }
+
+            selfStack.consumeItem(player);
+
+            if (player == null) {
+                selfBlock.onPlacedOnSide(world, blockPos, side, xHit, yHit);
+            } else {
+                selfBlock.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
+            }
+
+            selfBlock.onPlacedByWorld(world, blockPos);
+
+            if (selfBlock.isEntityTile && selfStack.getData().containsKey("tileEntityData")) {
+                final var tileEntity = world.getTileEntity(blockPos);
+                if (tileEntity != null) {
+                    tileEntity.readAdditionalData(selfStack.getData().getCompound("tileEntityData"));
+                }
+            }
+
+            world.notifyBlockChange(blockPos, selfBlock);
+            world.playBlockSoundEffect(
+                player,
+                blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F,
+                selfBlock, EnumBlockSoundEffectType.PLACE
+            );
+            return true;
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/item/Item.java b/game/core/src/main/java/net/minecraft/core/item/Item.java
index 5434bbcdd..1ff7f6a8c 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Item.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Item.java
@@ -216,6 +216,14 @@ public class Item implements ITaggable<Item>, IItemConvertible {
         return this.maxDamage;
     }
 
+    public boolean interactsWithFluid(@NotNull ItemStack selfStack) {
+        return false;
+    }
+
+    public boolean interactsWithEntity(@NotNull ItemStack selfStack, @NotNull Entity entity) {
+        return entity.isSelectable();
+    }
+
     @Deprecated
     public final boolean onUseItemOnBlock(@NotNull final ItemStack selfStack, @Nullable final Player player, @NotNull final World world, final int blockX, final int blockY, final int blockZ, @NotNull final Side side, final double xPlaced, final double yPlaced) {
         return onUseOnBlock(selfStack, world, player, new TilePos(blockX, blockY, blockZ), side, xPlaced, yPlaced);
